\
\ This file allows reading and writing the EEPROM of the PIC.
\
\ $ProjectVersion: 0.52 $
\

\ eeprom-read reads the data from the address EEADR. The result can be
\ found in EEDATA

: eeprom-read ( -- )
    eepgd eecon1 bit-set
    rd eecon1 bit-set
;

\ ee@ is similar to @ for the EEPROM

: ee@ ( addr -- b ) eeadr ! eeprom-read eedata @ ;

\ eeprom-write expects the address in EEADR and the data in EEDATA

code eeprom-write ( -- )
    eecon1 adjust-bank eepgd bcf
    eecon1 wren bsf
    disable-interrupts
    55 movlw
    eecon2 movwf
    aa movlw
    eecon2 movwf
    eecon1 wr bsf
    eecon1 wren bcf
    restore-bank
    return
end-code
    
\ wait-for-eeprom waits for the end of a write operation

code wait-for-eeprom ( -- )
    eecon1 adjust-bank forth> drop
label: wait-for-eeprom0
    eecon1 wr btfsc
    wait-for-eeprom0 goto
    restore-bank
    return
end-code

\ ee! is similar to ! for the EEPROM

: ee! ( b addr -- ) wait-for-eeprom eeadr ! eedata ! eeprom-write ;
    